<?php
/*
Plugin Name: WP-InternalLink
Plugin URI: http://www.delphiarea.com/products/wordpress-plugins/wp-internallink/
Description: Adds a shortcode to your WordPress, so that you can easily reference another post or page in your posts without being worry about future changes in the permalink structure or even domain name. In addition, you can use the shortcode to insert the link to an attachment, post's comments, category's posts, tag's posts, and author's posts.
Version: 1.0
Author: Kambiz R. Khojasteh
Author URI: kambiz@delphiarea.com
Tags: shortcode, link, url, page, post, attachment, comments, category, tag, author
*/

add_shortcode('url', 'url_shortcode');
function url_shortcode($atts) {
	$feed = 0;
	if (isset($atts['feed'])) {
		$feed = (($atts['feed']) == '1') || ((strtolower($atts['feed'])) == 'yes');
		unset($atts['feed']);
	}
	if (empty($atts)) {
		if ($feed)
		return get_bloginfo('rss2_url');
	else
		return get_bloginfo('url');
	}
	else {
		foreach($atts as $type => $id) {
			switch ($type) {
				case 'page':
					$id = post_name_to_id($id, 'page');
					return get_permalink($id);
				case 'post':
					$id = post_name_to_id($id, 'post');
					return get_permalink($id);
				case 'attachment':
					$id = post_name_to_id($id, 'attachment');
					return get_permalink($id);
				case 'comments':
					$id = post_name_to_id($id, array('page', 'post', 'attachment'));
					if ($feed)
						return get_post_comments_feed_link($id);
					else
						return get_permalink($id) . '#comments';
				case 'category':
					$id = taxonomy_slug_to_id($id, 'category');
					if ($feed)
						return get_category_feed_link($id);
					else
						return get_category_link($id);
				case 'tag':
					$id = taxonomy_slug_to_id($id, 'post_tag');
					if ($feed)
						return get_tag_feed_link($id);
					else
						return get_tag_link($id);
				case 'author':
					if ($feed)
						return get_author_feed_link($id);
					else
						return get_author_link($id);
			}
		}
	}
}

function post_name_to_id($name, $type) {
	global $wpdb;
	if (is_numeric($name))
		$id = $name;
	else {
		if (is_array($type))
			$type = implode("','", $type);
		$query = "SELECT ID FROM $wpdb->posts WHERE (post_name = '%s') AND (post_type IN ('$type')) LIMIT 1";
		$id = $wpdb->get_var($wpdb->prepare($query, $name));
	}
	return intval($id);
}

function taxonomy_slug_to_id($slug, $taxonomy) {
	if (is_numeric($slug))
		$id = $slug;
	else {
		$term = get_term_by('slug', $slug, $taxonomy);
		if ($term)
			$id	= $term->term_id;
		else
			$id = 0;
	}
	return intval($id);
}

?>
